﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
/* Inclusione Threading */
using System.Threading;

namespace ProdCons{

    class ProdCons{

        static void Main(string[] args){

            /* Creazione del buffer condiviso */
            SynchronizedBuffer buffer = new SynchronizedBuffer(10);
            /* Creazione di un produttore e di un consumatore */
            Producer prod = new Producer(buffer, 100);
            Consumer cons = new Consumer(buffer);

            /* Creazione ed avvio di un thread per il produttore ed uno per il consumatore */
            Thread thCons = new Thread(cons.consume);
            Thread thProd = new Thread(prod.produce);
            thCons.Start();
            thProd.Start();

            /* Aspetta che i due thread terminino l'esecuzione */
            thProd.Join();
            thCons.Join();
 
            Console.WriteLine("Esecuzione del programma terminata");
            Console.Read();
        }
    }
}
