import java.lang.Thread;

/* Consumatore. Legge dati dal buffer a ciclo continuo e li stampa. 
   Termina l'esecuzione quando incontra il carattere 0 (zero) */
class Consumer implements Runnable{
  private SynchronizedBuffer buffer;
  
  public Consumer(SynchronizedBuffer buffer){
    this.buffer = buffer;
  }
  
  public void run(){
    char value = 'a';
    System.out.println("Consumatore: esecuzione iniziata");
    do{
      try{
        value = buffer.getElement();
        System.out.println("Consumatore: ho letto il valore " + value);
      }catch(BufferException E){
        System.out.println("Produttore: buffer vuoto, aspetto!");
        try{
          Thread.sleep(20);
        }catch(InterruptedException iE){}
      }
    }while(value != '0');
    System.out.println("Consumatore: esecuzione terminata");
  }
}