import java.lang.Thread;

public class ProdCons{
  public static void main(String[] args){
    /* Creazione del buffer condiviso */
    SynchronizedBuffer buffer = new SynchronizedBuffer(10);

    /* Creazione di un produttore e di un consumatore */
    Consumer cons = new Consumer(buffer);
    Producer prod = new Producer(buffer, 100);
    
    /* Creazione ed avvio di un thread per il produttore ed uno per il consumatore */
    Thread thCons = new Thread(cons);
    Thread thProd = new Thread(prod);
    thCons.start();
    thProd.start();
    
    /* Aspetta che i due thread terminino l'esecuzione */
    try {
      thProd.join();
    }catch (InterruptedException iE){}
    try {
      thCons.join();
    }catch (InterruptedException iE){}
    
    System.out.println("Esecuzione del programma terminata");
  }
}