﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ProdCons{

    /* Consumatore. Legge dati dal buffer a ciclo continuo e li stampa. 
       Termina l'esecuzione quando incontra il carattere 0 (zero) */
    class Consumer{

        private SynchronizedBuffer buffer;
  
        public Consumer(SynchronizedBuffer buffer){
            this.buffer = buffer;
        }
  
        public void consume(){
            char value;

            Console.WriteLine("Consumatore: esecuzione iniziata");

            do{
                value = buffer.getElement();
                Console.WriteLine("Consumatore: ho letto il valore " + value);
            }while(value != '0');

            Console.WriteLine("Consumatore: esecuzione terminata");
        }
    }
}
