#include <stdio.h>
#include <windows.h>

int main(int argc, char *argv[])
{
  /* Valore da ricevere attraverso la pipe */
  char value;
  /* Buffer per la scrittura in output */
  char buffer[512];
  /* Caratteri presenti nel buffer */
  int length;
  /* Byte letti o scritti con ReadFile e WriteFile */
  DWORD dwRead, dwWritten; 
  /* Handle per l'I/O */
  HANDLE hStdin, hStdout, hStderr;

  /* Standard output */
  hStdout = GetStdHandle(STD_OUTPUT_HANDLE); 
  /* Standard Input. Il processo padre lo collega alla pipe */
  hStdin = GetStdHandle(STD_INPUT_HANDLE); 
  /* Standard Error. Il processo padre lo collega all'input da tastiera
     come brutto trucco per poter aspettare la pressione di un tasto per
     la chiusura! */
  hStderr = GetStdHandle(STD_ERROR_HANDLE); 

  do{
    ReadFile(hStdin, &value, 1, &dwRead, NULL); 
    length = sprintf(buffer, "Consumatore: ho letto il valore %c\n", value);
    WriteFile(hStdout, buffer, length, &dwWritten, NULL);
  }while(value != '0');

  puts("Consumatore: esecuzione terminata\n");
  /* Aspetta un input da tastiera per poter uscire */
  ReadFile(hStderr, &value, 1, &dwRead, NULL); 
  return 0;
}
